Skip to content
Start here

Update project

client.Pages.Projects.Edit(ctx, projectName, params) (*Project, error)
PATCH/accounts/{account_id}/pages/projects/{project_name}

Set new attributes for an existing project. Modify environment variables. To delete an environment variable, set the key to null.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Pages Write
ParametersExpand Collapse
projectName string

Name of the project.

params ProjectEditParams
AccountID param.Field[string]

Path param: Identifier.

maxLength32
BuildConfig param.Field[ProjectEditParamsBuildConfig]optional

Body param: Configs for the project build process.

BuildCaching booloptional

Enable build caching for the project.

BuildCommand stringoptional

Command used to build project.

DestinationDir stringoptional

Output directory of the build.

RootDir stringoptional

Directory to run the command.

WebAnalyticsTag stringoptional

The classifying tag for analytics.

WebAnalyticsToken stringoptional

The auth token for analytics.

DeploymentConfigs param.Field[ProjectEditParamsDeploymentConfigs]optional

Body param: Configs for deployments in a project.

Preview ProjectEditParamsDeploymentConfigsPreviewoptional

Configs for preview deploys.

AIBindings map[string, ProjectEditParamsDeploymentConfigsPreviewAIBindings]optional

Constellation bindings used for Pages Functions.

ProjectID string
AlwaysUseLatestCompatibilityDate booloptional

Whether to always use the latest compatibility date for Pages Functions.

AnalyticsEngineDatasets map[string, ProjectEditParamsDeploymentConfigsPreviewAnalyticsEngineDatasets]optional

Analytics Engine bindings used for Pages Functions.

Dataset string

Name of the dataset.

Browsers map[string, ProjectEditParamsDeploymentConfigsPreviewBrowsers]optional

Browser bindings used for Pages Functions.

BuildImageMajorVersion int64optional

The major version of the build image to use for Pages Functions.

CompatibilityDate stringoptional

Compatibility date used for Pages Functions.

CompatibilityFlags []stringoptional

Compatibility flags used for Pages Functions.

D1Databases map[string, ProjectEditParamsDeploymentConfigsPreviewD1Databases]optional

D1 databases used for Pages Functions.

ID string

UUID of the D1 database.

DurableObjectNamespaces map[string, ProjectEditParamsDeploymentConfigsPreviewDurableObjectNamespaces]optional

Durable Object namespaces used for Pages Functions.

NamespaceID string

ID of the Durable Object namespace.

EnvVars map[string, ProjectEditParamsDeploymentConfigsPreviewEnvVars]optional

Environment variables used for builds and Pages Functions.

One of the following:
type ProjectEditParamsDeploymentConfigsPreviewEnvVarsPagesPlainTextEnvVar struct{…}

A plaintext environment variable.

Type ProjectEditParamsDeploymentConfigsPreviewEnvVarsPagesPlainTextEnvVarType
Value string

Environment variable value.

type ProjectEditParamsDeploymentConfigsPreviewEnvVarsPagesSecretTextEnvVar struct{…}

An encrypted environment variable.

Type ProjectEditParamsDeploymentConfigsPreviewEnvVarsPagesSecretTextEnvVarType
Value string

Secret value.

FailOpen booloptional

Whether to fail open when the deployment config cannot be applied.

HyperdriveBindings map[string, ProjectEditParamsDeploymentConfigsPreviewHyperdriveBindings]optional

Hyperdrive bindings used for Pages Functions.

ID string
KVNamespaces map[string, ProjectEditParamsDeploymentConfigsPreviewKVNamespaces]optional

KV namespaces used for Pages Functions.

NamespaceID string

ID of the KV namespace.

Limits ProjectEditParamsDeploymentConfigsPreviewLimitsoptional

Limits for Pages Functions.

CPUMs int64

CPU time limit in milliseconds.

MTLSCertificates map[string, ProjectEditParamsDeploymentConfigsPreviewMTLSCertificates]optional

mTLS bindings used for Pages Functions.

CertificateID string
Placement ProjectEditParamsDeploymentConfigsPreviewPlacementoptional

Placement setting used for Pages Functions.

Mode string

Placement mode.

QueueProducers map[string, ProjectEditParamsDeploymentConfigsPreviewQueueProducers]optional

Queue Producer bindings used for Pages Functions.

Name string

Name of the Queue.

R2Buckets map[string, ProjectEditParamsDeploymentConfigsPreviewR2Buckets]optional

R2 buckets used for Pages Functions.

Name string

Name of the R2 bucket.

Jurisdiction stringoptional

Jurisdiction of the R2 bucket.

Services map[string, ProjectEditParamsDeploymentConfigsPreviewServices]optional

Services used for Pages Functions.

Service string

The Service name.

Entrypoint stringoptional

The entrypoint to bind to.

Environment stringoptional

The Service environment.

DeprecatedUsageModel ProjectEditParamsDeploymentConfigsPreviewUsageModeloptional
All new projects now use the Standard usage model.

The usage model for Pages Functions.

One of the following:
const ProjectEditParamsDeploymentConfigsPreviewUsageModelStandard ProjectEditParamsDeploymentConfigsPreviewUsageModel = "standard"
const ProjectEditParamsDeploymentConfigsPreviewUsageModelBundled ProjectEditParamsDeploymentConfigsPreviewUsageModel = "bundled"
const ProjectEditParamsDeploymentConfigsPreviewUsageModelUnbound ProjectEditParamsDeploymentConfigsPreviewUsageModel = "unbound"
VectorizeBindings map[string, ProjectEditParamsDeploymentConfigsPreviewVectorizeBindings]optional

Vectorize bindings used for Pages Functions.

IndexName string
WranglerConfigHash stringoptional

Hash of the Wrangler configuration used for the deployment.

Production ProjectEditParamsDeploymentConfigsProductionoptional

Configs for production deploys.

AIBindings map[string, ProjectEditParamsDeploymentConfigsProductionAIBindings]optional

Constellation bindings used for Pages Functions.

ProjectID string
AlwaysUseLatestCompatibilityDate booloptional

Whether to always use the latest compatibility date for Pages Functions.

AnalyticsEngineDatasets map[string, ProjectEditParamsDeploymentConfigsProductionAnalyticsEngineDatasets]optional

Analytics Engine bindings used for Pages Functions.

Dataset string

Name of the dataset.

Browsers map[string, ProjectEditParamsDeploymentConfigsProductionBrowsers]optional

Browser bindings used for Pages Functions.

BuildImageMajorVersion int64optional

The major version of the build image to use for Pages Functions.

CompatibilityDate stringoptional

Compatibility date used for Pages Functions.

CompatibilityFlags []stringoptional

Compatibility flags used for Pages Functions.

D1Databases map[string, ProjectEditParamsDeploymentConfigsProductionD1Databases]optional

D1 databases used for Pages Functions.

ID string

UUID of the D1 database.

DurableObjectNamespaces map[string, ProjectEditParamsDeploymentConfigsProductionDurableObjectNamespaces]optional

Durable Object namespaces used for Pages Functions.

NamespaceID string

ID of the Durable Object namespace.

EnvVars map[string, ProjectEditParamsDeploymentConfigsProductionEnvVars]optional

Environment variables used for builds and Pages Functions.

One of the following:
type ProjectEditParamsDeploymentConfigsProductionEnvVarsPagesPlainTextEnvVar struct{…}

A plaintext environment variable.

Type ProjectEditParamsDeploymentConfigsProductionEnvVarsPagesPlainTextEnvVarType
Value string

Environment variable value.

type ProjectEditParamsDeploymentConfigsProductionEnvVarsPagesSecretTextEnvVar struct{…}

An encrypted environment variable.

Type ProjectEditParamsDeploymentConfigsProductionEnvVarsPagesSecretTextEnvVarType
Value string

Secret value.

FailOpen booloptional

Whether to fail open when the deployment config cannot be applied.

HyperdriveBindings map[string, ProjectEditParamsDeploymentConfigsProductionHyperdriveBindings]optional

Hyperdrive bindings used for Pages Functions.

ID string
KVNamespaces map[string, ProjectEditParamsDeploymentConfigsProductionKVNamespaces]optional

KV namespaces used for Pages Functions.

NamespaceID string

ID of the KV namespace.

Limits ProjectEditParamsDeploymentConfigsProductionLimitsoptional

Limits for Pages Functions.

CPUMs int64

CPU time limit in milliseconds.

MTLSCertificates map[string, ProjectEditParamsDeploymentConfigsProductionMTLSCertificates]optional

mTLS bindings used for Pages Functions.

CertificateID string
Placement ProjectEditParamsDeploymentConfigsProductionPlacementoptional

Placement setting used for Pages Functions.

Mode string

Placement mode.

QueueProducers map[string, ProjectEditParamsDeploymentConfigsProductionQueueProducers]optional

Queue Producer bindings used for Pages Functions.

Name string

Name of the Queue.

R2Buckets map[string, ProjectEditParamsDeploymentConfigsProductionR2Buckets]optional

R2 buckets used for Pages Functions.

Name string

Name of the R2 bucket.

Jurisdiction stringoptional

Jurisdiction of the R2 bucket.

Services map[string, ProjectEditParamsDeploymentConfigsProductionServices]optional

Services used for Pages Functions.

Service string

The Service name.

Entrypoint stringoptional

The entrypoint to bind to.

Environment stringoptional

The Service environment.

DeprecatedUsageModel ProjectEditParamsDeploymentConfigsProductionUsageModeloptional
All new projects now use the Standard usage model.

The usage model for Pages Functions.

One of the following:
const ProjectEditParamsDeploymentConfigsProductionUsageModelStandard ProjectEditParamsDeploymentConfigsProductionUsageModel = "standard"
const ProjectEditParamsDeploymentConfigsProductionUsageModelBundled ProjectEditParamsDeploymentConfigsProductionUsageModel = "bundled"
const ProjectEditParamsDeploymentConfigsProductionUsageModelUnbound ProjectEditParamsDeploymentConfigsProductionUsageModel = "unbound"
VectorizeBindings map[string, ProjectEditParamsDeploymentConfigsProductionVectorizeBindings]optional

Vectorize bindings used for Pages Functions.

IndexName string
WranglerConfigHash stringoptional

Hash of the Wrangler configuration used for the deployment.

Name param.Field[string]optional

Body param: Name of the project.

ProductionBranch param.Field[string]optional

Body param: Production branch of the project. Used to identify production deployments.

Source param.Field[ProjectEditParamsSource]optional

Body param: Configs for the project source control.

Config ProjectEditParamsSourceConfig
DeprecatedDeploymentsEnabled booloptional
Use `production_deployments_enabled` and `preview_deployment_setting` for more granular control.

Whether to enable automatic deployments when pushing to the source repository. When disabled, no deployments (production or preview) will be triggered automatically.

Owner stringoptional

The owner of the repository.

OwnerID stringoptional

The owner ID of the repository.

PathExcludes []stringoptional

A list of paths that should be excluded from triggering a preview deployment. Wildcard syntax (*) is supported.

PathIncludes []stringoptional

A list of paths that should be watched to trigger a preview deployment. Wildcard syntax (*) is supported.

PrCommentsEnabled booloptional

Whether to enable PR comments.

PreviewBranchExcludes []stringoptional

A list of branches that should not trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewBranchIncludes []stringoptional

A list of branches that should trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewDeploymentSetting ProjectEditParamsSourceConfigPreviewDeploymentSettingoptional

Controls whether commits to preview branches trigger a preview deployment.

One of the following:
const ProjectEditParamsSourceConfigPreviewDeploymentSettingAll ProjectEditParamsSourceConfigPreviewDeploymentSetting = "all"
const ProjectEditParamsSourceConfigPreviewDeploymentSettingNone ProjectEditParamsSourceConfigPreviewDeploymentSetting = "none"
const ProjectEditParamsSourceConfigPreviewDeploymentSettingCustom ProjectEditParamsSourceConfigPreviewDeploymentSetting = "custom"
ProductionBranch stringoptional

The production branch of the repository.

ProductionDeploymentsEnabled booloptional

Whether to trigger a production deployment on commits to the production branch.

RepoID stringoptional

The ID of the repository.

RepoName stringoptional

The name of the repository.

Type ProjectEditParamsSourceType

The source control management provider.

One of the following:
const ProjectEditParamsSourceTypeGitHub ProjectEditParamsSourceType = "github"
const ProjectEditParamsSourceTypeGitlab ProjectEditParamsSourceType = "gitlab"
ReturnsExpand Collapse
type Project struct{…}
ID string

ID of the project.

CanonicalDeployment Deployment

Most recent production deployment of the project.

ID string

Id of the deployment.

Aliases []string

A list of alias URLs pointing to this deployment.

BuildConfig DeploymentBuildConfig

Configs for the project build process.

WebAnalyticsTag string

The classifying tag for analytics.

WebAnalyticsToken string

The auth token for analytics.

BuildCaching booloptional

Enable build caching for the project.

BuildCommand stringoptional

Command used to build project.

DestinationDir stringoptional

Assets output directory of the build.

RootDir stringoptional

Directory to run the command.

CreatedOn Time

When the deployment was created.

formatdate-time
DeploymentTrigger DeploymentDeploymentTrigger

Info about what caused the deployment.

Metadata DeploymentDeploymentTriggerMetadata

Additional info about the trigger.

Branch string

Where the trigger happened.

CommitDirty bool

Whether the deployment trigger commit was dirty.

CommitHash string

Hash of the deployment trigger commit.

CommitMessage string

Message of the deployment trigger commit.

Type DeploymentDeploymentTriggerType

What caused the deployment.

One of the following:
const DeploymentDeploymentTriggerTypeGitHubPush DeploymentDeploymentTriggerType = "github:push"
const DeploymentDeploymentTriggerTypeADHoc DeploymentDeploymentTriggerType = "ad_hoc"
const DeploymentDeploymentTriggerTypeDeployHook DeploymentDeploymentTriggerType = "deploy_hook"
EnvVars map[string, DeploymentEnvVar]

Environment variables used for builds and Pages Functions.

One of the following:
type DeploymentEnvVarsPagesPlainTextEnvVar struct{…}

A plaintext environment variable.

Type DeploymentEnvVarsPagesPlainTextEnvVarType
Value string

Environment variable value.

type DeploymentEnvVarsPagesSecretTextEnvVar struct{…}

An encrypted environment variable.

Type DeploymentEnvVarsPagesSecretTextEnvVarType
Value string

Secret value.

Environment DeploymentEnvironment

Type of deploy.

One of the following:
const DeploymentEnvironmentPreview DeploymentEnvironment = "preview"
const DeploymentEnvironmentProduction DeploymentEnvironment = "production"
IsSkipped bool

If the deployment has been skipped.

LatestStage Stage

The status of the deployment.

EndedOn Time

When the stage ended.

formatdate-time
Name StageName

The current build stage.

One of the following:
const StageNameQueued StageName = "queued"
const StageNameInitialize StageName = "initialize"
const StageNameCloneRepo StageName = "clone_repo"
const StageNameBuild StageName = "build"
const StageNameDeploy StageName = "deploy"
StartedOn Time

When the stage started.

formatdate-time
Status StageStatus

State of the current stage.

One of the following:
const StageStatusSuccess StageStatus = "success"
const StageStatusIdle StageStatus = "idle"
const StageStatusActive StageStatus = "active"
const StageStatusFailure StageStatus = "failure"
const StageStatusCanceled StageStatus = "canceled"
ModifiedOn Time

When the deployment was last modified.

formatdate-time
ProjectID string

Id of the project.

ProjectName string

Name of the project.

ShortID string

Short Id (8 character) of the deployment.

Source DeploymentSource

Configs for the project source control.

Config DeploymentSourceConfig
DeprecatedDeploymentsEnabled bool
Use `production_deployments_enabled` and `preview_deployment_setting` for more granular control.

Whether to enable automatic deployments when pushing to the source repository. When disabled, no deployments (production or preview) will be triggered automatically.

Owner string

The owner of the repository.

OwnerID string

The owner ID of the repository.

PathExcludes []string

A list of paths that should be excluded from triggering a preview deployment. Wildcard syntax (*) is supported.

PathIncludes []string

A list of paths that should be watched to trigger a preview deployment. Wildcard syntax (*) is supported.

PrCommentsEnabled bool

Whether to enable PR comments.

PreviewBranchExcludes []string

A list of branches that should not trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewBranchIncludes []string

A list of branches that should trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewDeploymentSetting DeploymentSourceConfigPreviewDeploymentSetting

Controls whether commits to preview branches trigger a preview deployment.

One of the following:
const DeploymentSourceConfigPreviewDeploymentSettingAll DeploymentSourceConfigPreviewDeploymentSetting = "all"
const DeploymentSourceConfigPreviewDeploymentSettingNone DeploymentSourceConfigPreviewDeploymentSetting = "none"
const DeploymentSourceConfigPreviewDeploymentSettingCustom DeploymentSourceConfigPreviewDeploymentSetting = "custom"
ProductionBranch string

The production branch of the repository.

ProductionDeploymentsEnabled bool

Whether to trigger a production deployment on commits to the production branch.

RepoID string

The ID of the repository.

RepoName string

The name of the repository.

Type DeploymentSourceType

The source control management provider.

One of the following:
const DeploymentSourceTypeGitHub DeploymentSourceType = "github"
const DeploymentSourceTypeGitlab DeploymentSourceType = "gitlab"
Stages []Stage

List of past stages.

EndedOn Time

When the stage ended.

formatdate-time
Name StageName

The current build stage.

One of the following:
const StageNameQueued StageName = "queued"
const StageNameInitialize StageName = "initialize"
const StageNameCloneRepo StageName = "clone_repo"
const StageNameBuild StageName = "build"
const StageNameDeploy StageName = "deploy"
StartedOn Time

When the stage started.

formatdate-time
Status StageStatus

State of the current stage.

One of the following:
const StageStatusSuccess StageStatus = "success"
const StageStatusIdle StageStatus = "idle"
const StageStatusActive StageStatus = "active"
const StageStatusFailure StageStatus = "failure"
const StageStatusCanceled StageStatus = "canceled"
URL string

The live URL to view this deployment.

UsesFunctions booloptional

Whether the deployment uses functions.

CreatedOn Time

When the project was created.

formatdate-time
DeploymentConfigs ProjectDeploymentConfigs

Configs for deployments in a project.

Preview ProjectDeploymentConfigsPreview

Configs for preview deploys.

AlwaysUseLatestCompatibilityDate bool

Whether to always use the latest compatibility date for Pages Functions.

BuildImageMajorVersion int64

The major version of the build image to use for Pages Functions.

CompatibilityDate string

Compatibility date used for Pages Functions.

CompatibilityFlags []string

Compatibility flags used for Pages Functions.

EnvVars map[string, ProjectDeploymentConfigsPreviewEnvVar]

Environment variables used for builds and Pages Functions.

One of the following:
type ProjectDeploymentConfigsPreviewEnvVarsPagesPlainTextEnvVar struct{…}

A plaintext environment variable.

Type ProjectDeploymentConfigsPreviewEnvVarsPagesPlainTextEnvVarType
Value string

Environment variable value.

type ProjectDeploymentConfigsPreviewEnvVarsPagesSecretTextEnvVar struct{…}

An encrypted environment variable.

Type ProjectDeploymentConfigsPreviewEnvVarsPagesSecretTextEnvVarType
Value string

Secret value.

FailOpen bool

Whether to fail open when the deployment config cannot be applied.

DeprecatedUsageModel ProjectDeploymentConfigsPreviewUsageModel
All new projects now use the Standard usage model.

The usage model for Pages Functions.

One of the following:
const ProjectDeploymentConfigsPreviewUsageModelStandard ProjectDeploymentConfigsPreviewUsageModel = "standard"
const ProjectDeploymentConfigsPreviewUsageModelBundled ProjectDeploymentConfigsPreviewUsageModel = "bundled"
const ProjectDeploymentConfigsPreviewUsageModelUnbound ProjectDeploymentConfigsPreviewUsageModel = "unbound"
AIBindings map[string, ProjectDeploymentConfigsPreviewAIBinding]optional

Constellation bindings used for Pages Functions.

ProjectID string
AnalyticsEngineDatasets map[string, ProjectDeploymentConfigsPreviewAnalyticsEngineDataset]optional

Analytics Engine bindings used for Pages Functions.

Dataset string

Name of the dataset.

Browsers map[string, ProjectDeploymentConfigsPreviewBrowser]optional

Browser bindings used for Pages Functions.

D1Databases map[string, ProjectDeploymentConfigsPreviewD1Database]optional

D1 databases used for Pages Functions.

ID string

UUID of the D1 database.

DurableObjectNamespaces map[string, ProjectDeploymentConfigsPreviewDurableObjectNamespace]optional

Durable Object namespaces used for Pages Functions.

NamespaceID string

ID of the Durable Object namespace.

HyperdriveBindings map[string, ProjectDeploymentConfigsPreviewHyperdriveBinding]optional

Hyperdrive bindings used for Pages Functions.

ID string
KVNamespaces map[string, ProjectDeploymentConfigsPreviewKVNamespace]optional

KV namespaces used for Pages Functions.

NamespaceID string

ID of the KV namespace.

Limits ProjectDeploymentConfigsPreviewLimitsoptional

Limits for Pages Functions.

CPUMs int64

CPU time limit in milliseconds.

MTLSCertificates map[string, ProjectDeploymentConfigsPreviewMTLSCertificate]optional

mTLS bindings used for Pages Functions.

CertificateID string
Placement ProjectDeploymentConfigsPreviewPlacementoptional

Placement setting used for Pages Functions.

Mode string

Placement mode.

QueueProducers map[string, ProjectDeploymentConfigsPreviewQueueProducer]optional

Queue Producer bindings used for Pages Functions.

Name string

Name of the Queue.

R2Buckets map[string, ProjectDeploymentConfigsPreviewR2Bucket]optional

R2 buckets used for Pages Functions.

Name string

Name of the R2 bucket.

Jurisdiction stringoptional

Jurisdiction of the R2 bucket.

Services map[string, ProjectDeploymentConfigsPreviewService]optional

Services used for Pages Functions.

Environment string

The Service environment.

Service string

The Service name.

Entrypoint stringoptional

The entrypoint to bind to.

VectorizeBindings map[string, ProjectDeploymentConfigsPreviewVectorizeBinding]optional

Vectorize bindings used for Pages Functions.

IndexName string
WranglerConfigHash stringoptional

Hash of the Wrangler configuration used for the deployment.

Production ProjectDeploymentConfigsProduction

Configs for production deploys.

AlwaysUseLatestCompatibilityDate bool

Whether to always use the latest compatibility date for Pages Functions.

BuildImageMajorVersion int64

The major version of the build image to use for Pages Functions.

CompatibilityDate string

Compatibility date used for Pages Functions.

CompatibilityFlags []string

Compatibility flags used for Pages Functions.

EnvVars map[string, ProjectDeploymentConfigsProductionEnvVar]

Environment variables used for builds and Pages Functions.

One of the following:
type ProjectDeploymentConfigsProductionEnvVarsPagesPlainTextEnvVar struct{…}

A plaintext environment variable.

Type ProjectDeploymentConfigsProductionEnvVarsPagesPlainTextEnvVarType
Value string

Environment variable value.

type ProjectDeploymentConfigsProductionEnvVarsPagesSecretTextEnvVar struct{…}

An encrypted environment variable.

Type ProjectDeploymentConfigsProductionEnvVarsPagesSecretTextEnvVarType
Value string

Secret value.

FailOpen bool

Whether to fail open when the deployment config cannot be applied.

DeprecatedUsageModel ProjectDeploymentConfigsProductionUsageModel
All new projects now use the Standard usage model.

The usage model for Pages Functions.

One of the following:
const ProjectDeploymentConfigsProductionUsageModelStandard ProjectDeploymentConfigsProductionUsageModel = "standard"
const ProjectDeploymentConfigsProductionUsageModelBundled ProjectDeploymentConfigsProductionUsageModel = "bundled"
const ProjectDeploymentConfigsProductionUsageModelUnbound ProjectDeploymentConfigsProductionUsageModel = "unbound"
AIBindings map[string, ProjectDeploymentConfigsProductionAIBinding]optional

Constellation bindings used for Pages Functions.

ProjectID string
AnalyticsEngineDatasets map[string, ProjectDeploymentConfigsProductionAnalyticsEngineDataset]optional

Analytics Engine bindings used for Pages Functions.

Dataset string

Name of the dataset.

Browsers map[string, ProjectDeploymentConfigsProductionBrowser]optional

Browser bindings used for Pages Functions.

D1Databases map[string, ProjectDeploymentConfigsProductionD1Database]optional

D1 databases used for Pages Functions.

ID string

UUID of the D1 database.

DurableObjectNamespaces map[string, ProjectDeploymentConfigsProductionDurableObjectNamespace]optional

Durable Object namespaces used for Pages Functions.

NamespaceID string

ID of the Durable Object namespace.

HyperdriveBindings map[string, ProjectDeploymentConfigsProductionHyperdriveBinding]optional

Hyperdrive bindings used for Pages Functions.

ID string
KVNamespaces map[string, ProjectDeploymentConfigsProductionKVNamespace]optional

KV namespaces used for Pages Functions.

NamespaceID string

ID of the KV namespace.

Limits ProjectDeploymentConfigsProductionLimitsoptional

Limits for Pages Functions.

CPUMs int64

CPU time limit in milliseconds.

MTLSCertificates map[string, ProjectDeploymentConfigsProductionMTLSCertificate]optional

mTLS bindings used for Pages Functions.

CertificateID string
Placement ProjectDeploymentConfigsProductionPlacementoptional

Placement setting used for Pages Functions.

Mode string

Placement mode.

QueueProducers map[string, ProjectDeploymentConfigsProductionQueueProducer]optional

Queue Producer bindings used for Pages Functions.

Name string

Name of the Queue.

R2Buckets map[string, ProjectDeploymentConfigsProductionR2Bucket]optional

R2 buckets used for Pages Functions.

Name string

Name of the R2 bucket.

Jurisdiction stringoptional

Jurisdiction of the R2 bucket.

Services map[string, ProjectDeploymentConfigsProductionService]optional

Services used for Pages Functions.

Environment string

The Service environment.

Service string

The Service name.

Entrypoint stringoptional

The entrypoint to bind to.

VectorizeBindings map[string, ProjectDeploymentConfigsProductionVectorizeBinding]optional

Vectorize bindings used for Pages Functions.

IndexName string
WranglerConfigHash stringoptional

Hash of the Wrangler configuration used for the deployment.

Framework string

Framework the project is using.

FrameworkVersion string

Version of the framework the project is using.

LatestDeployment Deployment

Most recent deployment of the project.

ID string

Id of the deployment.

Aliases []string

A list of alias URLs pointing to this deployment.

BuildConfig DeploymentBuildConfig

Configs for the project build process.

WebAnalyticsTag string

The classifying tag for analytics.

WebAnalyticsToken string

The auth token for analytics.

BuildCaching booloptional

Enable build caching for the project.

BuildCommand stringoptional

Command used to build project.

DestinationDir stringoptional

Assets output directory of the build.

RootDir stringoptional

Directory to run the command.

CreatedOn Time

When the deployment was created.

formatdate-time
DeploymentTrigger DeploymentDeploymentTrigger

Info about what caused the deployment.

Metadata DeploymentDeploymentTriggerMetadata

Additional info about the trigger.

Branch string

Where the trigger happened.

CommitDirty bool

Whether the deployment trigger commit was dirty.

CommitHash string

Hash of the deployment trigger commit.

CommitMessage string

Message of the deployment trigger commit.

Type DeploymentDeploymentTriggerType

What caused the deployment.

One of the following:
const DeploymentDeploymentTriggerTypeGitHubPush DeploymentDeploymentTriggerType = "github:push"
const DeploymentDeploymentTriggerTypeADHoc DeploymentDeploymentTriggerType = "ad_hoc"
const DeploymentDeploymentTriggerTypeDeployHook DeploymentDeploymentTriggerType = "deploy_hook"
EnvVars map[string, DeploymentEnvVar]

Environment variables used for builds and Pages Functions.

One of the following:
type DeploymentEnvVarsPagesPlainTextEnvVar struct{…}

A plaintext environment variable.

Type DeploymentEnvVarsPagesPlainTextEnvVarType
Value string

Environment variable value.

type DeploymentEnvVarsPagesSecretTextEnvVar struct{…}

An encrypted environment variable.

Type DeploymentEnvVarsPagesSecretTextEnvVarType
Value string

Secret value.

Environment DeploymentEnvironment

Type of deploy.

One of the following:
const DeploymentEnvironmentPreview DeploymentEnvironment = "preview"
const DeploymentEnvironmentProduction DeploymentEnvironment = "production"
IsSkipped bool

If the deployment has been skipped.

LatestStage Stage

The status of the deployment.

EndedOn Time

When the stage ended.

formatdate-time
Name StageName

The current build stage.

One of the following:
const StageNameQueued StageName = "queued"
const StageNameInitialize StageName = "initialize"
const StageNameCloneRepo StageName = "clone_repo"
const StageNameBuild StageName = "build"
const StageNameDeploy StageName = "deploy"
StartedOn Time

When the stage started.

formatdate-time
Status StageStatus

State of the current stage.

One of the following:
const StageStatusSuccess StageStatus = "success"
const StageStatusIdle StageStatus = "idle"
const StageStatusActive StageStatus = "active"
const StageStatusFailure StageStatus = "failure"
const StageStatusCanceled StageStatus = "canceled"
ModifiedOn Time

When the deployment was last modified.

formatdate-time
ProjectID string

Id of the project.

ProjectName string

Name of the project.

ShortID string

Short Id (8 character) of the deployment.

Source DeploymentSource

Configs for the project source control.

Config DeploymentSourceConfig
DeprecatedDeploymentsEnabled bool
Use `production_deployments_enabled` and `preview_deployment_setting` for more granular control.

Whether to enable automatic deployments when pushing to the source repository. When disabled, no deployments (production or preview) will be triggered automatically.

Owner string

The owner of the repository.

OwnerID string

The owner ID of the repository.

PathExcludes []string

A list of paths that should be excluded from triggering a preview deployment. Wildcard syntax (*) is supported.

PathIncludes []string

A list of paths that should be watched to trigger a preview deployment. Wildcard syntax (*) is supported.

PrCommentsEnabled bool

Whether to enable PR comments.

PreviewBranchExcludes []string

A list of branches that should not trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewBranchIncludes []string

A list of branches that should trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewDeploymentSetting DeploymentSourceConfigPreviewDeploymentSetting

Controls whether commits to preview branches trigger a preview deployment.

One of the following:
const DeploymentSourceConfigPreviewDeploymentSettingAll DeploymentSourceConfigPreviewDeploymentSetting = "all"
const DeploymentSourceConfigPreviewDeploymentSettingNone DeploymentSourceConfigPreviewDeploymentSetting = "none"
const DeploymentSourceConfigPreviewDeploymentSettingCustom DeploymentSourceConfigPreviewDeploymentSetting = "custom"
ProductionBranch string

The production branch of the repository.

ProductionDeploymentsEnabled bool

Whether to trigger a production deployment on commits to the production branch.

RepoID string

The ID of the repository.

RepoName string

The name of the repository.

Type DeploymentSourceType

The source control management provider.

One of the following:
const DeploymentSourceTypeGitHub DeploymentSourceType = "github"
const DeploymentSourceTypeGitlab DeploymentSourceType = "gitlab"
Stages []Stage

List of past stages.

EndedOn Time

When the stage ended.

formatdate-time
Name StageName

The current build stage.

One of the following:
const StageNameQueued StageName = "queued"
const StageNameInitialize StageName = "initialize"
const StageNameCloneRepo StageName = "clone_repo"
const StageNameBuild StageName = "build"
const StageNameDeploy StageName = "deploy"
StartedOn Time

When the stage started.

formatdate-time
Status StageStatus

State of the current stage.

One of the following:
const StageStatusSuccess StageStatus = "success"
const StageStatusIdle StageStatus = "idle"
const StageStatusActive StageStatus = "active"
const StageStatusFailure StageStatus = "failure"
const StageStatusCanceled StageStatus = "canceled"
URL string

The live URL to view this deployment.

UsesFunctions booloptional

Whether the deployment uses functions.

Name string

Name of the project.

PreviewScriptName string

Name of the preview script.

ProductionBranch string

Production branch of the project. Used to identify production deployments.

ProductionScriptName string

Name of the production script.

UsesFunctions bool

Whether the project uses functions.

BuildConfig ProjectBuildConfigoptional

Configs for the project build process.

WebAnalyticsTag string

The classifying tag for analytics.

WebAnalyticsToken string

The auth token for analytics.

BuildCaching booloptional

Enable build caching for the project.

BuildCommand stringoptional

Command used to build project.

DestinationDir stringoptional

Assets output directory of the build.

RootDir stringoptional

Directory to run the command.

Domains []stringoptional

A list of associated custom domains for the project.

Source ProjectSourceoptional

Configs for the project source control.

Config ProjectSourceConfig
DeprecatedDeploymentsEnabled bool
Use `production_deployments_enabled` and `preview_deployment_setting` for more granular control.

Whether to enable automatic deployments when pushing to the source repository. When disabled, no deployments (production or preview) will be triggered automatically.

Owner string

The owner of the repository.

OwnerID string

The owner ID of the repository.

PathExcludes []string

A list of paths that should be excluded from triggering a preview deployment. Wildcard syntax (*) is supported.

PathIncludes []string

A list of paths that should be watched to trigger a preview deployment. Wildcard syntax (*) is supported.

PrCommentsEnabled bool

Whether to enable PR comments.

PreviewBranchExcludes []string

A list of branches that should not trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewBranchIncludes []string

A list of branches that should trigger a preview deployment. Wildcard syntax (*) is supported. Must be used with preview_deployment_setting set to custom.

PreviewDeploymentSetting ProjectSourceConfigPreviewDeploymentSetting

Controls whether commits to preview branches trigger a preview deployment.

One of the following:
const ProjectSourceConfigPreviewDeploymentSettingAll ProjectSourceConfigPreviewDeploymentSetting = "all"
const ProjectSourceConfigPreviewDeploymentSettingNone ProjectSourceConfigPreviewDeploymentSetting = "none"
const ProjectSourceConfigPreviewDeploymentSettingCustom ProjectSourceConfigPreviewDeploymentSetting = "custom"
ProductionBranch string

The production branch of the repository.

ProductionDeploymentsEnabled bool

Whether to trigger a production deployment on commits to the production branch.

RepoID string

The ID of the repository.

RepoName string

The name of the repository.

Type ProjectSourceType

The source control management provider.

One of the following:
const ProjectSourceTypeGitHub ProjectSourceType = "github"
const ProjectSourceTypeGitlab ProjectSourceType = "gitlab"
Subdomain stringoptional

The Cloudflare subdomain associated with the project.

Update project

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/pages"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  project, err := client.Pages.Projects.Edit(
    context.TODO(),
    "this-is-my-project-01",
    pages.ProjectEditParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", project.ID)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "7b162ea7-7367-4d67-bcde-1160995d5",
    "canonical_deployment": {
      "id": "f64788e9-fccd-4d4a-a28a-cb84f88f6",
      "aliases": [
        "https://branchname.projectname.pages.dev"
      ],
      "build_config": {
        "web_analytics_tag": "cee1c73f6e4743d0b5e6bb1a0bcaabcc",
        "web_analytics_token": "021e1057c18547eca7b79f2516f06o7x",
        "build_caching": true,
        "build_command": "npm run build",
        "destination_dir": "build",
        "root_dir": "/"
      },
      "created_on": "2021-03-09T00:55:03.923456Z",
      "deployment_trigger": {
        "metadata": {
          "branch": "main",
          "commit_dirty": false,
          "commit_hash": "ad9ccd918a81025731e10e40267e11273a263421",
          "commit_message": "Update index.html"
        },
        "type": "ad_hoc"
      },
      "env_vars": {
        "foo": {
          "type": "plain_text",
          "value": "hello world"
        }
      },
      "environment": "preview",
      "is_skipped": true,
      "latest_stage": {
        "ended_on": "2021-03-09T00:58:59.045655Z",
        "name": "deploy",
        "started_on": "2021-03-09T00:55:03.923456Z",
        "status": "success"
      },
      "modified_on": "2021-03-09T00:58:59.045655Z",
      "project_id": "7b162ea7-7367-4d67-bcde-1160995d5",
      "project_name": "this-is-my-project-01",
      "short_id": "f64788e9",
      "source": {
        "config": {
          "deployments_enabled": true,
          "owner": "my-org",
          "owner_id": "12345678",
          "path_excludes": [
            "string"
          ],
          "path_includes": [
            "string"
          ],
          "pr_comments_enabled": true,
          "preview_branch_excludes": [
            "string"
          ],
          "preview_branch_includes": [
            "string"
          ],
          "preview_deployment_setting": "all",
          "production_branch": "main",
          "production_deployments_enabled": true,
          "repo_id": "12345678",
          "repo_name": "my-repo"
        },
        "type": "github"
      },
      "stages": [
        {
          "ended_on": "2021-06-03T15:39:03.134378Z",
          "name": "queued",
          "started_on": "2021-06-03T15:38:15.608194Z",
          "status": "active"
        },
        {
          "ended_on": null,
          "name": "initialize",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "clone_repo",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "build",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "deploy",
          "started_on": null,
          "status": "idle"
        }
      ],
      "url": "https://f64788e9.ninjakittens.pages.dev",
      "uses_functions": true
    },
    "created_on": "2017-01-01T00:00:00Z",
    "deployment_configs": {
      "preview": {
        "always_use_latest_compatibility_date": false,
        "build_image_major_version": 3,
        "compatibility_date": "2025-01-01",
        "compatibility_flags": [
          "url_standard"
        ],
        "env_vars": {
          "foo": {
            "type": "plain_text",
            "value": "hello world"
          }
        },
        "fail_open": true,
        "usage_model": "standard",
        "ai_bindings": {
          "AI_BINDING": {
            "project_id": "some-project-id"
          }
        },
        "analytics_engine_datasets": {
          "ANALYTICS_ENGINE_BINDING": {
            "dataset": "api_analytics"
          }
        },
        "browsers": {
          "BROWSER": {}
        },
        "d1_databases": {
          "D1_BINDING": {
            "id": "445e2955-951a-43f8-a35b-a4d0c8138f63"
          }
        },
        "durable_object_namespaces": {
          "DO_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "hyperdrive_bindings": {
          "HYPERDRIVE": {
            "id": "a76a99bc342644deb02c38d66082262a"
          }
        },
        "kv_namespaces": {
          "KV_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "limits": {
          "cpu_ms": 100
        },
        "mtls_certificates": {
          "MTLS": {
            "certificate_id": "d7cdd17c-916f-4cb7-aabe-585eb382ec4e"
          }
        },
        "placement": {
          "mode": "smart"
        },
        "queue_producers": {
          "QUEUE_PRODUCER_BINDING": {
            "name": "some-queue"
          }
        },
        "r2_buckets": {
          "R2_BINDING": {
            "name": "some-bucket",
            "jurisdiction": "eu"
          }
        },
        "services": {
          "SERVICE_BINDING": {
            "environment": "production",
            "service": "example-worker",
            "entrypoint": "MyHandler"
          }
        },
        "vectorize_bindings": {
          "VECTORIZE": {
            "index_name": "my_index"
          }
        },
        "wrangler_config_hash": "abc123def456"
      },
      "production": {
        "always_use_latest_compatibility_date": false,
        "build_image_major_version": 3,
        "compatibility_date": "2025-01-01",
        "compatibility_flags": [
          "url_standard"
        ],
        "env_vars": {
          "foo": {
            "type": "plain_text",
            "value": "hello world"
          }
        },
        "fail_open": true,
        "usage_model": "standard",
        "ai_bindings": {
          "AI_BINDING": {
            "project_id": "some-project-id"
          }
        },
        "analytics_engine_datasets": {
          "ANALYTICS_ENGINE_BINDING": {
            "dataset": "api_analytics"
          }
        },
        "browsers": {
          "BROWSER": {}
        },
        "d1_databases": {
          "D1_BINDING": {
            "id": "445e2955-951a-43f8-a35b-a4d0c8138f63"
          }
        },
        "durable_object_namespaces": {
          "DO_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "hyperdrive_bindings": {
          "HYPERDRIVE": {
            "id": "a76a99bc342644deb02c38d66082262a"
          }
        },
        "kv_namespaces": {
          "KV_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "limits": {
          "cpu_ms": 100
        },
        "mtls_certificates": {
          "MTLS": {
            "certificate_id": "d7cdd17c-916f-4cb7-aabe-585eb382ec4e"
          }
        },
        "placement": {
          "mode": "smart"
        },
        "queue_producers": {
          "QUEUE_PRODUCER_BINDING": {
            "name": "some-queue"
          }
        },
        "r2_buckets": {
          "R2_BINDING": {
            "name": "some-bucket",
            "jurisdiction": "eu"
          }
        },
        "services": {
          "SERVICE_BINDING": {
            "environment": "production",
            "service": "example-worker",
            "entrypoint": "MyHandler"
          }
        },
        "vectorize_bindings": {
          "VECTORIZE": {
            "index_name": "my_index"
          }
        },
        "wrangler_config_hash": "abc123def456"
      }
    },
    "framework": "framework",
    "framework_version": "framework_version",
    "latest_deployment": {
      "id": "f64788e9-fccd-4d4a-a28a-cb84f88f6",
      "aliases": [
        "https://branchname.projectname.pages.dev"
      ],
      "build_config": {
        "web_analytics_tag": "cee1c73f6e4743d0b5e6bb1a0bcaabcc",
        "web_analytics_token": "021e1057c18547eca7b79f2516f06o7x",
        "build_caching": true,
        "build_command": "npm run build",
        "destination_dir": "build",
        "root_dir": "/"
      },
      "created_on": "2021-03-09T00:55:03.923456Z",
      "deployment_trigger": {
        "metadata": {
          "branch": "main",
          "commit_dirty": false,
          "commit_hash": "ad9ccd918a81025731e10e40267e11273a263421",
          "commit_message": "Update index.html"
        },
        "type": "ad_hoc"
      },
      "env_vars": {
        "foo": {
          "type": "plain_text",
          "value": "hello world"
        }
      },
      "environment": "preview",
      "is_skipped": true,
      "latest_stage": {
        "ended_on": "2021-03-09T00:58:59.045655Z",
        "name": "deploy",
        "started_on": "2021-03-09T00:55:03.923456Z",
        "status": "success"
      },
      "modified_on": "2021-03-09T00:58:59.045655Z",
      "project_id": "7b162ea7-7367-4d67-bcde-1160995d5",
      "project_name": "this-is-my-project-01",
      "short_id": "f64788e9",
      "source": {
        "config": {
          "deployments_enabled": true,
          "owner": "my-org",
          "owner_id": "12345678",
          "path_excludes": [
            "string"
          ],
          "path_includes": [
            "string"
          ],
          "pr_comments_enabled": true,
          "preview_branch_excludes": [
            "string"
          ],
          "preview_branch_includes": [
            "string"
          ],
          "preview_deployment_setting": "all",
          "production_branch": "main",
          "production_deployments_enabled": true,
          "repo_id": "12345678",
          "repo_name": "my-repo"
        },
        "type": "github"
      },
      "stages": [
        {
          "ended_on": "2021-06-03T15:39:03.134378Z",
          "name": "queued",
          "started_on": "2021-06-03T15:38:15.608194Z",
          "status": "active"
        },
        {
          "ended_on": null,
          "name": "initialize",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "clone_repo",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "build",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "deploy",
          "started_on": null,
          "status": "idle"
        }
      ],
      "url": "https://f64788e9.ninjakittens.pages.dev",
      "uses_functions": true
    },
    "name": "this-is-my-project-01",
    "preview_script_name": "pages-worker--1234567-preview",
    "production_branch": "main",
    "production_script_name": "pages-worker--1234567-production",
    "uses_functions": true,
    "build_config": {
      "web_analytics_tag": "cee1c73f6e4743d0b5e6bb1a0bcaabcc",
      "web_analytics_token": "021e1057c18547eca7b79f2516f06o7x",
      "build_caching": true,
      "build_command": "npm run build",
      "destination_dir": "build",
      "root_dir": "/"
    },
    "domains": [
      "customdomain.com",
      "customdomain.org"
    ],
    "source": {
      "config": {
        "deployments_enabled": true,
        "owner": "my-org",
        "owner_id": "12345678",
        "path_excludes": [
          "string"
        ],
        "path_includes": [
          "string"
        ],
        "pr_comments_enabled": true,
        "preview_branch_excludes": [
          "string"
        ],
        "preview_branch_includes": [
          "string"
        ],
        "preview_deployment_setting": "all",
        "production_branch": "main",
        "production_deployments_enabled": true,
        "repo_id": "12345678",
        "repo_name": "my-repo"
      },
      "type": "github"
    },
    "subdomain": "helloworld.pages.dev"
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "7b162ea7-7367-4d67-bcde-1160995d5",
    "canonical_deployment": {
      "id": "f64788e9-fccd-4d4a-a28a-cb84f88f6",
      "aliases": [
        "https://branchname.projectname.pages.dev"
      ],
      "build_config": {
        "web_analytics_tag": "cee1c73f6e4743d0b5e6bb1a0bcaabcc",
        "web_analytics_token": "021e1057c18547eca7b79f2516f06o7x",
        "build_caching": true,
        "build_command": "npm run build",
        "destination_dir": "build",
        "root_dir": "/"
      },
      "created_on": "2021-03-09T00:55:03.923456Z",
      "deployment_trigger": {
        "metadata": {
          "branch": "main",
          "commit_dirty": false,
          "commit_hash": "ad9ccd918a81025731e10e40267e11273a263421",
          "commit_message": "Update index.html"
        },
        "type": "ad_hoc"
      },
      "env_vars": {
        "foo": {
          "type": "plain_text",
          "value": "hello world"
        }
      },
      "environment": "preview",
      "is_skipped": true,
      "latest_stage": {
        "ended_on": "2021-03-09T00:58:59.045655Z",
        "name": "deploy",
        "started_on": "2021-03-09T00:55:03.923456Z",
        "status": "success"
      },
      "modified_on": "2021-03-09T00:58:59.045655Z",
      "project_id": "7b162ea7-7367-4d67-bcde-1160995d5",
      "project_name": "this-is-my-project-01",
      "short_id": "f64788e9",
      "source": {
        "config": {
          "deployments_enabled": true,
          "owner": "my-org",
          "owner_id": "12345678",
          "path_excludes": [
            "string"
          ],
          "path_includes": [
            "string"
          ],
          "pr_comments_enabled": true,
          "preview_branch_excludes": [
            "string"
          ],
          "preview_branch_includes": [
            "string"
          ],
          "preview_deployment_setting": "all",
          "production_branch": "main",
          "production_deployments_enabled": true,
          "repo_id": "12345678",
          "repo_name": "my-repo"
        },
        "type": "github"
      },
      "stages": [
        {
          "ended_on": "2021-06-03T15:39:03.134378Z",
          "name": "queued",
          "started_on": "2021-06-03T15:38:15.608194Z",
          "status": "active"
        },
        {
          "ended_on": null,
          "name": "initialize",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "clone_repo",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "build",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "deploy",
          "started_on": null,
          "status": "idle"
        }
      ],
      "url": "https://f64788e9.ninjakittens.pages.dev",
      "uses_functions": true
    },
    "created_on": "2017-01-01T00:00:00Z",
    "deployment_configs": {
      "preview": {
        "always_use_latest_compatibility_date": false,
        "build_image_major_version": 3,
        "compatibility_date": "2025-01-01",
        "compatibility_flags": [
          "url_standard"
        ],
        "env_vars": {
          "foo": {
            "type": "plain_text",
            "value": "hello world"
          }
        },
        "fail_open": true,
        "usage_model": "standard",
        "ai_bindings": {
          "AI_BINDING": {
            "project_id": "some-project-id"
          }
        },
        "analytics_engine_datasets": {
          "ANALYTICS_ENGINE_BINDING": {
            "dataset": "api_analytics"
          }
        },
        "browsers": {
          "BROWSER": {}
        },
        "d1_databases": {
          "D1_BINDING": {
            "id": "445e2955-951a-43f8-a35b-a4d0c8138f63"
          }
        },
        "durable_object_namespaces": {
          "DO_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "hyperdrive_bindings": {
          "HYPERDRIVE": {
            "id": "a76a99bc342644deb02c38d66082262a"
          }
        },
        "kv_namespaces": {
          "KV_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "limits": {
          "cpu_ms": 100
        },
        "mtls_certificates": {
          "MTLS": {
            "certificate_id": "d7cdd17c-916f-4cb7-aabe-585eb382ec4e"
          }
        },
        "placement": {
          "mode": "smart"
        },
        "queue_producers": {
          "QUEUE_PRODUCER_BINDING": {
            "name": "some-queue"
          }
        },
        "r2_buckets": {
          "R2_BINDING": {
            "name": "some-bucket",
            "jurisdiction": "eu"
          }
        },
        "services": {
          "SERVICE_BINDING": {
            "environment": "production",
            "service": "example-worker",
            "entrypoint": "MyHandler"
          }
        },
        "vectorize_bindings": {
          "VECTORIZE": {
            "index_name": "my_index"
          }
        },
        "wrangler_config_hash": "abc123def456"
      },
      "production": {
        "always_use_latest_compatibility_date": false,
        "build_image_major_version": 3,
        "compatibility_date": "2025-01-01",
        "compatibility_flags": [
          "url_standard"
        ],
        "env_vars": {
          "foo": {
            "type": "plain_text",
            "value": "hello world"
          }
        },
        "fail_open": true,
        "usage_model": "standard",
        "ai_bindings": {
          "AI_BINDING": {
            "project_id": "some-project-id"
          }
        },
        "analytics_engine_datasets": {
          "ANALYTICS_ENGINE_BINDING": {
            "dataset": "api_analytics"
          }
        },
        "browsers": {
          "BROWSER": {}
        },
        "d1_databases": {
          "D1_BINDING": {
            "id": "445e2955-951a-43f8-a35b-a4d0c8138f63"
          }
        },
        "durable_object_namespaces": {
          "DO_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "hyperdrive_bindings": {
          "HYPERDRIVE": {
            "id": "a76a99bc342644deb02c38d66082262a"
          }
        },
        "kv_namespaces": {
          "KV_BINDING": {
            "namespace_id": "5eb63bbbe01eeed093cb22bb8f5acdc3"
          }
        },
        "limits": {
          "cpu_ms": 100
        },
        "mtls_certificates": {
          "MTLS": {
            "certificate_id": "d7cdd17c-916f-4cb7-aabe-585eb382ec4e"
          }
        },
        "placement": {
          "mode": "smart"
        },
        "queue_producers": {
          "QUEUE_PRODUCER_BINDING": {
            "name": "some-queue"
          }
        },
        "r2_buckets": {
          "R2_BINDING": {
            "name": "some-bucket",
            "jurisdiction": "eu"
          }
        },
        "services": {
          "SERVICE_BINDING": {
            "environment": "production",
            "service": "example-worker",
            "entrypoint": "MyHandler"
          }
        },
        "vectorize_bindings": {
          "VECTORIZE": {
            "index_name": "my_index"
          }
        },
        "wrangler_config_hash": "abc123def456"
      }
    },
    "framework": "framework",
    "framework_version": "framework_version",
    "latest_deployment": {
      "id": "f64788e9-fccd-4d4a-a28a-cb84f88f6",
      "aliases": [
        "https://branchname.projectname.pages.dev"
      ],
      "build_config": {
        "web_analytics_tag": "cee1c73f6e4743d0b5e6bb1a0bcaabcc",
        "web_analytics_token": "021e1057c18547eca7b79f2516f06o7x",
        "build_caching": true,
        "build_command": "npm run build",
        "destination_dir": "build",
        "root_dir": "/"
      },
      "created_on": "2021-03-09T00:55:03.923456Z",
      "deployment_trigger": {
        "metadata": {
          "branch": "main",
          "commit_dirty": false,
          "commit_hash": "ad9ccd918a81025731e10e40267e11273a263421",
          "commit_message": "Update index.html"
        },
        "type": "ad_hoc"
      },
      "env_vars": {
        "foo": {
          "type": "plain_text",
          "value": "hello world"
        }
      },
      "environment": "preview",
      "is_skipped": true,
      "latest_stage": {
        "ended_on": "2021-03-09T00:58:59.045655Z",
        "name": "deploy",
        "started_on": "2021-03-09T00:55:03.923456Z",
        "status": "success"
      },
      "modified_on": "2021-03-09T00:58:59.045655Z",
      "project_id": "7b162ea7-7367-4d67-bcde-1160995d5",
      "project_name": "this-is-my-project-01",
      "short_id": "f64788e9",
      "source": {
        "config": {
          "deployments_enabled": true,
          "owner": "my-org",
          "owner_id": "12345678",
          "path_excludes": [
            "string"
          ],
          "path_includes": [
            "string"
          ],
          "pr_comments_enabled": true,
          "preview_branch_excludes": [
            "string"
          ],
          "preview_branch_includes": [
            "string"
          ],
          "preview_deployment_setting": "all",
          "production_branch": "main",
          "production_deployments_enabled": true,
          "repo_id": "12345678",
          "repo_name": "my-repo"
        },
        "type": "github"
      },
      "stages": [
        {
          "ended_on": "2021-06-03T15:39:03.134378Z",
          "name": "queued",
          "started_on": "2021-06-03T15:38:15.608194Z",
          "status": "active"
        },
        {
          "ended_on": null,
          "name": "initialize",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "clone_repo",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "build",
          "started_on": null,
          "status": "idle"
        },
        {
          "ended_on": null,
          "name": "deploy",
          "started_on": null,
          "status": "idle"
        }
      ],
      "url": "https://f64788e9.ninjakittens.pages.dev",
      "uses_functions": true
    },
    "name": "this-is-my-project-01",
    "preview_script_name": "pages-worker--1234567-preview",
    "production_branch": "main",
    "production_script_name": "pages-worker--1234567-production",
    "uses_functions": true,
    "build_config": {
      "web_analytics_tag": "cee1c73f6e4743d0b5e6bb1a0bcaabcc",
      "web_analytics_token": "021e1057c18547eca7b79f2516f06o7x",
      "build_caching": true,
      "build_command": "npm run build",
      "destination_dir": "build",
      "root_dir": "/"
    },
    "domains": [
      "customdomain.com",
      "customdomain.org"
    ],
    "source": {
      "config": {
        "deployments_enabled": true,
        "owner": "my-org",
        "owner_id": "12345678",
        "path_excludes": [
          "string"
        ],
        "path_includes": [
          "string"
        ],
        "pr_comments_enabled": true,
        "preview_branch_excludes": [
          "string"
        ],
        "preview_branch_includes": [
          "string"
        ],
        "preview_deployment_setting": "all",
        "production_branch": "main",
        "production_deployments_enabled": true,
        "repo_id": "12345678",
        "repo_name": "my-repo"
      },
      "type": "github"
    },
    "subdomain": "helloworld.pages.dev"
  },
  "success": true
}